<!--
/**
 * @name            README
 * @namespace       doc
 * @type            Markdown
 * @platform        md
 * @status          stable
 * @menu            Documentation           /doc/readme
 *
 * @since           2.0.0
 * @author    Olivier Bossel <olivier.bossel@gmail.com> (https://coffeekraken.io)
 */
-->

{{#> layout-readme }}

## SClass

This package expose a simple `SClass` class that you can use as base class for yours.

## Features

-   Provide a `settings` internal property to store the one passed in the constructor
-   Provide a `metas` property to store metas informations about the class
-   Provide a `toPlainObject` method to convert you class to json
-   And more...

## Usage

## How to start using it?

Here's a simple example of how to extends the `SClass` class:

```js
import __SClass from '@coffeekraken/s-class';
class MyClass extends __SClass {
    constructor() {
        super({
            hello: 'world',
        });
        console.log(this.settings); // {hello:'world'}
    }
}
```

Alternatively, you can extend an existing class with the `SClass` like so:

```js
import __SClass from '@coffeekraken/s-class';
class MyPromise extends __SClass.extends(Promise) {
    constructor() {
        // etc...
    }
}
```

## API

For more information about the API, please check out [the API documentation](/api/@coffeekraken.s-class.shared.SClass)

{{/ layout-readme }}
